{{- define "image.mariadb" -}}
  mariadb:10.5.19-amd64
{{- end -}}
{{- define "image.phpmyadmin" -}}
  phpmyadmin:5.2.1-amd64
{{- end -}}
{{- define "image.tiny-tools" -}}
  tiny-tools:3.12-amd64
{{- end -}}
{{- define "image.consul" -}}
  consul:1.7.14-amd64
{{- end -}}
{{- define "image.redis" -}}
  redis:6.2.1-amd64
{{- end -}}
{{- define "image.rabbitmq" -}}
  rabbitmq:3.9.20-management-amd64
{{- end -}}
{{- define "image.k8s-dashboard" -}}
  k8s-dashboard-imanager:v1.8.3-amd64
{{- end -}}
{{- define "image.metrics-server" -}}
  metrics-server:v0.4.5-amd64
{{- end -}}
{{- define "image.node-exporter" -}}
  node-exporter:v0.15.2-amd64
{{- end -}}
{{- define "image.kube-state-metrics" -}}
  kube-state-metrics:v2.2.0-amd64
{{- end -}}
{{- define "image.nginx-ingress-controller" -}}
  nginx-ingress-controller:v1.2.1-amd64
{{- end -}}
{{- define "image.prometheus" -}}
  prometheus:v2.41.0-amd64
{{- end -}}
{{- define "image.nfs-client-provisioner" -}}
  nfs-subdir-external-provisioner:v4.0.2-amd64
{{- end -}}
{{- define "image.postgres" -}}
  postgres:10.16-alpine-amd64
{{- end -}}
{{- define "image.postgis" -}}
  postgis-imanager:10-amd64
{{- end -}}
{{- define "image.elasticsearch" -}}
  elasticsearch:6.8.21-amd64
{{- end -}}
{{- define "image.keycloak-proxy" -}}
  keycloak-proxy:2.0-amd64
{{- end -}}
{{- define "image.memcached" -}}
  memcached:1.5.3-amd64
{{- end -}}
{{- define "image.postgresql.pgpool" -}}
  pgpool:4.2.1-debian-10-r37-amd64
{{- end -}}
{{- define "image.postgresql.repmgr" -}}
  postgresql-repmgr:11.10.0-debian-10-r78-amd64
{{- end -}}
{{- define "image.alpine-with-oracle-client" -}}
  alpine-with-oracle-client:1.0-amd64
{{- end -}}
{{- define "image.alpine-with-fonts" -}}
  alpine-with-fonts:1.0-amd64
{{- end -}}
{{- define "image.blackbox-exporter" -}}
  blackbox-exporter:v0.18.0-amd64
{{- end -}}
{{- define "image.blackbox-exporter-proxy" -}}
  blackbox-exporter-proxy:1.0-amd64
{{- end -}}
{{- define "elasticsearch_xpack_ml_enable" -}}
  true
{{- end -}}
{{- define "spark_worker_tag" -}}
  3.3.0-hadoop3.3-iobjects{{ include "deploy_image_tag" . }}
{{- end -}}
{{- define "metrics.node_memory_MemTotal" -}}
  node_memory_MemTotal
{{- end -}}
{{- define "metrics.node_memory_MemFree" -}}
  node_memory_MemFree
{{- end -}}
{{- define "metrics.node_memory_Cached" -}}
  node_memory_Cached
{{- end -}}
{{- define "metrics.node_memory_Buffers" -}}
  node_memory_Buffers
{{- end -}}
{{- define "metrics.node_filesystem_size" -}}
  node_filesystem_size
{{- end -}}
{{- define "metrics.node_filesystem_avail" -}}
  node_filesystem_avail
{{- end -}}
{{- define "metrics.node_network_receive_bytes" -}}
  node_network_receive_bytes
{{- end -}}
{{- define "metrics.node_network_transmit_bytes" -}}
  node_network_transmit_bytes
{{- end -}}
{{- define "keycloak_postgresql_addr" -}}
  keycloak-postgresql
{{- end -}}
{{- define "keycloak_postgresql_tpl" -}}
apiVersion: v1
kind: Service
metadata:
  name: keycloak-postgresql-pgpool
  labels:
{{ include "icloud_native.labels" . | indent 4 }}
spec:
  type: ClusterIP
  ports:
    - name: tcp-postgresql
      port: 5432
      targetPort: postgresql
      protocol: TCP
  selector:
    app: keycloak-postgresql-pgpool
---
apiVersion: v1
kind: Service
metadata:
  name: keycloak-postgresql-headless
  labels:
{{ include "icloud_native.labels" . | indent 4 }}
spec:
  type: ClusterIP
  clusterIP: None
  ports:
    - name: tcp-postgresql
      port: 5432
      targetPort: postgresql
      protocol: TCP
  selector:
    app: keycloak-postgresql
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: keycloak-postgresql-ha-postgresql-hooks-scripts
  labels:
{{ include "icloud_native.labels" . | indent 4 }}
data:
  pre-stop.sh: |-
    #!/bin/bash
    set -o errexit
    set -o pipefail
    set -o nounset

    # Debug section
    exec 3>&1
    exec 4>&2

    # Load Libraries
    . /opt/bitnami/scripts/liblog.sh
    . /opt/bitnami/scripts/libpostgresql.sh
    . /opt/bitnami/scripts/librepmgr.sh

    # Auxiliary functions
    is_new_primary_ready() {
        return_value=1
        currenty_primary_node="$(repmgr_get_primary_node)"
        currenty_primary_host="$(echo $currenty_primary_node | awk '{print $1}')"

        info "$currenty_primary_host != $REPMGR_NODE_NETWORK_NAME"
        if [[ $(echo $currenty_primary_node | wc -w) -eq 2 ]] && [[ "$currenty_primary_host" != "$REPMGR_NODE_NETWORK_NAME" ]]; then
            info "New primary detected, leaving the cluster..."
            return_value=0
        else
            info "Waiting for a new primary to be available..."
        fi
        return $return_value
    }

    export MODULE="pre-stop-hook"

    if [[ "${BITNAMI_DEBUG}" == "true" ]]; then
        info "Bash debug is on"
    else
        info "Bash debug is off"
        exec 1>/dev/null
        exec 2>/dev/null
    fi

    # Load PostgreSQL & repmgr environment variables
    . /opt/bitnami/scripts/postgresql-env.sh

    postgresql_enable_nss_wrapper

    # Prepare env vars for managing roles
    primary_node="$(repmgr_get_primary_node)"
    primary_host="$(echo $primary_node | awk '{print $1}')"

    # Stop postgresql for graceful exit.
    postgresql_stop

    if [[ "$primary_host" == "$REPMGR_NODE_NETWORK_NAME" ]]; then
        info "Primary node need to wait for a new primary node before leaving the cluster"
        retry_while is_new_primary_ready 10 5
    else
        info "Standby node doesn't need to wait, leaving the cluster."
    fi
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: keycloak-postgresql-pgpool
  labels: 
{{ include "icloud_native.labels" . | indent 4 }}
    app: keycloak-postgresql-pgpool
    group: base-service
  annotations:
    scale: unscalable
    trace: untraceable
    description: icloud_native_keycloak_postgresql_pgpool_description
    topoProperty: "{'name':'keycloak-postgresql-pgpool','outerPosition':'left','type':'keycloak-postgresql','isPivot':'false','index':1,'parents':[{'name':'keycloak-postgresql','description':'icloud_native_keycloak_postgresql_pool_topoProperty_keycloak_postgresql_cluster_description'}]}"
spec:
  replicas: 1
  selector:
    matchLabels:
      app: keycloak-postgresql-pgpool
  template:
    metadata:
      labels:
        app: keycloak-postgresql-pgpool
    spec:
{{ include "affinity" . | indent 6 }}
{{ include "tolerations" . | indent 6 }} 
      imagePullSecrets:
      - name: "{{ template "deploy_image_pull_secret" . }}"
      securityContext:
        fsGroup: 1001
      volumes:
      - name:  timezone
        hostPath:
          path: /etc/localtime
      initContainers:
        - image: {{ template "deploy_registry" . }}/{{ template "deploy_image_namespace" . }}/{{ template "image.tiny-tools" . }}
          imagePullPolicy: IfNotPresent
          command: ["/sbin/sysctl", "-w", "kernel.shmmax=18446744073692774399"]
          name: pgpool-init
          securityContext:
            privileged: true
          resources:
            limits:
              cpu: 1
              memory: 1Gi
            requests:
              cpu: 100m
              memory: 200Mi
      containers:
        - name: pgpool
          image: {{ template "deploy_registry" . }}/{{ template "deploy_image_namespace" . }}/{{ template "image.postgresql.pgpool" . }}
          imagePullPolicy: {{ template "deploy_image_pull_policy" . }}
          securityContext:
            runAsUser: 1001
          env:
            - name: BITNAMI_DEBUG
              value: "false"
            - name: PGPOOL_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
            - name: PGPOOL_BACKEND_NODES
              value: 0:keycloak-postgresql-0.keycloak-postgresql-headless.$(PGPOOL_NAMESPACE).svc.cluster.local:5432,1:keycloak-postgresql-1.keycloak-postgresql-headless.$(PGPOOL_NAMESPACE).svc.cluster.local:5432,2:keycloak-postgresql-2.keycloak-postgresql-headless.$(PGPOOL_NAMESPACE).svc.cluster.local:5432,
            - name: PGPOOL_SR_CHECK_USER
              value: "repmgr"
            - name: PGPOOL_SR_CHECK_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: icloud-native-secret
                  key: keycloak.postgresql.repmgr.password
            - name: PGPOOL_SR_CHECK_DATABASE
              value: "postgres"
            - name: PGPOOL_ENABLE_LDAP
              value: "no"
            - name: PGPOOL_POSTGRES_USERNAME
              value: "supermap"
            - name: PGPOOL_POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: icloud-native-secret
                  key: keycloak.postgresql.password
            - name: PGPOOL_ADMIN_USERNAME
              value: "admin"
            - name: PGPOOL_ADMIN_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: icloud-native-secret
                  key: keycloak.postgresql.pgpool.admin.password
            - name: PGPOOL_ENABLE_LOAD_BALANCING
              value: "yes"
            - name: PGPOOL_ENABLE_LOG_CONNECTIONS
              value: "no"
            - name: PGPOOL_ENABLE_LOG_HOSTNAME
              value: "yes"
            - name: PGPOOL_ENABLE_LOG_PER_NODE_STATEMENT
              value: "no"
            - name: PGPOOL_ENABLE_TLS
              value: "no"
            - name: PGPOOL_HEALTH_CHECK_PERIOD
              value: "60"
            - name: PGPOOL_HEALTH_CHECK_TIMEOUT
              value: "30"
            - name: TZ
              valueFrom:
                configMapKeyRef:
                  name: timezone-config
                  key: timezone
          ports:
            - name: postgresql
              containerPort: 5432
              protocol: TCP
          livenessProbe:
            exec:
              command:
                - /opt/bitnami/scripts/pgpool/healthcheck.sh
            initialDelaySeconds: 20
            periodSeconds: 30
            timeoutSeconds: 20
            successThreshold: 1
            failureThreshold: 5
          readinessProbe:
            exec:
              command:
                - bash
                - -ec
                - PGPASSWORD=${PGPOOL_POSTGRES_PASSWORD} psql -U "supermap" -d "keycloak" -h /opt/bitnami/pgpool/tmp -tA -c "SELECT 1" >/dev/null
            initialDelaySeconds: 20
            periodSeconds: 30
            timeoutSeconds: 20
            successThreshold: 1
            failureThreshold: 5
          volumeMounts:
            - mountPath: /etc/localtime
              name: timezone
            - mountPath: /etc/timezone
              name: timezone
          resources:
            limits:
              cpu: 1
              memory: 1Gi
            requests:
              cpu: 100m
              memory: 200Mi
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: keycloak-postgresql
  labels:
{{ include "icloud_native.labels" . | indent 4 }}
    app: keycloak-postgresql
    group: base-service
  annotations:
    scale: unscalable
    trace: untraceable
    servicemesh.metrics/service: "(keycloak-postgresql|keycloak-postgresql-headless)"
    description: "icloud_native_keycloak_postgresql_cluster_description"
    topoProperty: "{'name':'keycloak-postgresql','outerPosition':'left','type':'keycloak-postgresql','isPivot':'false','index':2,'parents':[]}"
spec:
  serviceName: keycloak-postgresql-headless
  replicas: 3
  updateStrategy:
    type: RollingUpdate
  podManagementPolicy: Parallel
  selector:
    matchLabels:
      app: keycloak-postgresql
  template:
    metadata:
      labels:
        app: keycloak-postgresql
    spec:
{{ include "affinity" . | indent 6 }}
{{ include "tolerations" . | indent 6 }} 
      imagePullSecrets:
      - name: "{{ template "deploy_image_pull_secret" . }}"
      securityContext:
        fsGroup: 1001
      initContainers:
      - image: {{ template "deploy_registry" . }}/{{ template "deploy_image_namespace" . }}/{{ template "image.tiny-tools" }}
        imagePullPolicy: {{ template "deploy_image_pull_policy" . }}
        command: ["/bin/sh", "-c"]
        args:
        - >
          chmod -R 777 /opt/data;
        name: keycloak-postgresql-init
        securityContext:
          privileged: true
        volumeMounts:
        - name: data
          mountPath: /opt/data
        resources:
            limits:
              cpu: 1
              memory: 2Gi
            requests:
              cpu: 100m
              memory: 200Mi
      containers:
        - name: postgresql
          lifecycle:
            preStop:
              exec:
                command:
                  - /pre-stop.sh
          image: {{ template "deploy_registry" . }}/{{ template "deploy_image_namespace" . }}/{{ template "image.postgresql.repmgr" . }}
          imagePullPolicy: {{ template "deploy_image_pull_policy" . }}
          securityContext:
            runAsUser: 1001
          # Auxiliary vars to populate environment variables
          env:
            - name: BITNAMI_DEBUG
              value: "false"
            # PostgreSQL configuration
            - name: POSTGRESQL_VOLUME_DIR
              value: "/bitnami/postgresql"
            - name: PGDATA
              value: "/bitnami/postgresql/data"
            - name: POSTGRES_USER
              value: "supermap"
            - name: POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: icloud-native-secret
                  key: keycloak.postgresql.password
            - name: POSTGRES_DB
              value: "keycloak"
            - name: POSTGRESQL_LOG_HOSTNAME
              value: "true"
            - name: POSTGRESQL_LOG_CONNECTIONS
              value: "false"
            - name: POSTGRESQL_LOG_DISCONNECTIONS
              value: "false"
            - name: POSTGRESQL_PGAUDIT_LOG_CATALOG
              value: "off"
            - name: POSTGRESQL_CLIENT_MIN_MESSAGES
              value: "error"
            - name: POSTGRESQL_SHARED_PRELOAD_LIBRARIES
              value: "pgaudit, repmgr"
            # Repmgr configuration
            - name: MY_POD_NAME
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
            - name: REPMGR_UPGRADE_EXTENSION
              value: "no"
            - name: REPMGR_PGHBA_TRUST_ALL
              value: "no"
            - name: REPMGR_MOUNTED_CONF_DIR
              value: "/bitnami/repmgr/conf"
            - name: REPMGR_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
            - name: REPMGR_PARTNER_NODES
              value: keycloak-postgresql-0.keycloak-postgresql-headless.$(REPMGR_NAMESPACE).svc.cluster.local,keycloak-postgresql-1.keycloak-postgresql-headless.$(REPMGR_NAMESPACE).svc.cluster.local,keycloak-postgresql-2.keycloak-postgresql-headless.$(REPMGR_NAMESPACE).svc.cluster.local,
            - name: REPMGR_PRIMARY_HOST
              value: "keycloak-postgresql-0.keycloak-postgresql-headless.$(REPMGR_NAMESPACE).svc.cluster.local"
            - name: REPMGR_NODE_NAME
              value: "$(MY_POD_NAME)"
            - name: REPMGR_NODE_NETWORK_NAME
              value: "$(MY_POD_NAME).keycloak-postgresql-headless.$(REPMGR_NAMESPACE).svc.cluster.local"
            - name: REPMGR_LOG_LEVEL
              value: "NOTICE"
            - name: REPMGR_CONNECT_TIMEOUT
              value: "60"
            - name: REPMGR_RECONNECT_ATTEMPTS
              value: "3"
            - name: REPMGR_RECONNECT_INTERVAL
              value: "30"
            - name: REPMGR_USERNAME
              value: "repmgr"
            - name: REPMGR_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: icloud-native-secret
                  key: keycloak.postgresql.repmgr.password
            - name: REPMGR_DATABASE
              value: "repmgr"
            - name: POSTGRESQL_NUM_SYNCHRONOUS_REPLICAS
              value: "1"
          ports:
            - name: postgresql
              containerPort: 5432
              protocol: TCP
          livenessProbe:
            exec:
              command:
                - bash
                - -ec
                - 'PGPASSWORD=$POSTGRES_PASSWORD psql -w -U "supermap" -d "keycloak"  -h 127.0.0.1 -c "SELECT 1"'
            initialDelaySeconds: 30
            periodSeconds: 30
            timeoutSeconds: 5
            successThreshold: 1
            failureThreshold: 6
          readinessProbe:
            exec:
              command:
                - bash
                - -ec
                - 'PGPASSWORD=$POSTGRES_PASSWORD psql -w -U "supermap" -d "keycloak"  -h 127.0.0.1 -c "SELECT 1"'
            initialDelaySeconds: 5
            periodSeconds: 10
            timeoutSeconds: 5
            successThreshold: 1
            failureThreshold: 6
          startupProbe:
            exec:
              command:
                - bash
                - -ec
                - 'PGPASSWORD=$POSTGRES_PASSWORD psql -w -U "supermap" -d "keycloak"  -h 127.0.0.1 -c "SELECT 1"'
            failureThreshold: 20
            periodSeconds: 30
            timeoutSeconds: 20
          resources:
            limits:
              cpu: 2
              memory: 2Gi
            requests:
              cpu: 100m
              memory: 200Mi
          volumeMounts:
            - name: data
              mountPath: /bitnami/postgresql
            - name: hooks-scripts
              mountPath: /pre-stop.sh
              subPath: pre-stop.sh
            - mountPath: /etc/localtime
              name: timezone
            - mountPath: /etc/timezone
              name: timezone
      volumes:
        - name: hooks-scripts
          configMap:
            name: keycloak-postgresql-ha-postgresql-hooks-scripts
            defaultMode: 0755
        - name:  timezone
          hostPath:
            path: /etc/localtime
  volumeClaimTemplates:
    - metadata:
        name: data
      spec:
        accessModes:
          - "ReadWriteMany"
        resources:
          requests:
            storage: "8Gi"
        storageClassName: {{ template "storage_class_name" . }}
{{- end -}}