{{- define "appset_id" -}}
1
{{- end }}
{{- define "deploy_kubernetes_master_url" -}}
  {{ .Values.deploy_kubernetes_master_url | default "https://kubernetes.default.svc" }}
{{- end -}}
{{- define "deploy_registry" -}}
  {{ .Values.deploy_registry | default "registry.cn-beijing.aliyuncs.com" }}
{{- end -}}
{{- define "deploy_nfs_server" -}}
  {{ .Values.deploy_nfs_server | default "none" }}
{{- end -}}
{{- define "deploy_nfs_path" -}}
  {{ .Values.deploy_nfs_path | default "/" }}
{{- end -}}
{{- define "deploy_service_protocol" -}}
  {{ .Values.deploy_service_protocol | default "http" }}
{{- end -}}
{{- define "deploy_image_pull_policy" -}}
  {{ .Values.deploy_image_pull_policy | default "IfNotPresent" }}
{{- end -}}
{{- define "deploy_image_pull_secret" -}}
  {{ .Values.deploy_image_pull_secret | default "none" }}
{{- end -}}
{{- define "deploy_cpu_limit" -}}
  {{ .Values.deploy_cpu_limit | default "1" }}
{{- end -}}
{{- define "deploy_memory_limit" -}}
  {{ .Values.deploy_memory_limit | default "4Gi" }}
{{- end -}}
{{- define "deploy_gis_app_tag" -}}
  {{ .Values.deploy_gis_app_tag | default "latest" }}
{{- end -}}
{{- define "deploy_image_tag" -}}
  {{ .Values.deploy_image_tag | default "11.1.1-amd64" }}
{{- end -}}
{{- define "deploy_gateway_port" -}}
  {{ .Values.deploy_gateway_port | default "32222" }}
{{- end -}}
{{- define "deploy_disable_bslicense_local_volume" -}}
  {{ .Values.deploy_disable_bslicense_local_volume | default "false" }}
{{- end -}}
{{- define "deploy_disable_hbase_nfs_volume" -}}
  {{ .Values.deploy_disable_hbase_nfs_volume | default "false" }}
{{- end -}}
{{- define "deploy_timezone" -}}
  {{ .Values.deploy_timezone | default "Asia/Shanghai" }}
{{- end -}}
{{- define "bslicense_storage_class" -}}
  {{- if not .Values.deploy_disable_bslicense_local_volume -}}
    pvc-bslicense-data
  {{- else if .Values.deploy_nfs_server -}}
    appset-storage-class-gisappset
  {{- else if .Values.deploy_storage_class_name -}}
    {{ .Values.deploy_storage_class_name }}
  {{- else -}}
    pvc-bslicense-data
  {{- end -}}
{{- end -}}
{{- define "elasticsearch_cluster_name" -}}
kubernetes-logging
{{- end }}
{{- define "elasticsearch_address" -}}
elasticsearch
{{- end }}
{{- define "elasticsearch_restport" -}}
9200
{{- end }}
{{- define "grafana_service" -}}
grafana
{{- end }}
{{- define "kibana_basepath" -}}
/kibana
{{- end }}
{{- define "appset_name" -}}
giscloudsuite
{{- end }}
{{- define "license_validity_remind_day_configmap" -}}
  {{ .Values.license_validity_remind_day_configmap | default "license-expire-remind" }}
{{- end -}}
{{- define "service_instance_rebuild_enabled" -}}
  {{ .Values.service_instance_rebuild_enabled | default "true" }}
{{- end -}}
{{- define "service_node_rebuild_enabled" -}}
  {{ .Values.service_node_rebuild_enabled | default "true" }}
{{- end -}}
{{- define "service_instance_abnormal_threshold" -}}
  {{ .Values.service_instance_abnormal_threshold | default "2" }}
{{- end -}}
{{- define "service_node_instance_abnormal_threshold" -}}
  {{ .Values.service_node_instance_abnormal_threshold | default "8" }}
{{- end -}}
{{- define "service_instance_status_update_period" -}}
  {{ .Values.service_instance_status_update_period | default "30" }}
{{- end -}}
{{- define "elasticsearch_url" -}}
http://elasticsearch:9300
{{- end }}
{{- define "keycloak_token_timeout_second" -}}
  {{ .Values.deploy_keycloak_token_timeout_second | default "1800" }}
{{- end -}}
{{- define "gateway_url" -}}
  {{- if .Values.deploy_gateway_domain -}}
    {{ template "deploy_service_protocol" . }}://{{ .Values.deploy_gateway_domain }}
  {{- else -}}
    none
  {{- end -}}
{{- end -}}
{{- define "gateway_domain_ingress" -}}
  {{ .Values.deploy_gateway_domain | default "none" }}
{{- end -}}
{{- define "gateway_address_reg" -}}
  {{- if .Values.deploy_gateway_domain -}}
    {{ template "deploy_service_protocol" . }}://{{ .Values.deploy_gateway_domain }}
  {{- else -}}
    {{ template "deploy_service_protocol" . }}://{{ .Values.deploy_kubernetes_public_ip }}:{{ template "deploy_gateway_port" . }}
  {{- end -}}
{{- end -}}
{{- define "proxy_port" -}}
  {{- if .Values.deploy_gateway_domain -}}
    {{- if eq (include "deploy_service_protocol" .) "https" }}
      443
    {{- else -}}
      80
    {{- end -}}
  {{- else -}}
    {{ include "deploy_gateway_port" . }}
  {{- end -}}
{{- end -}}
{{- define "proxy_server_root_url" -}}
  {{- if .Values.deploy_gateway_domain -}}
    {{ include "deploy_service_protocol" . }}://{{ .Values.deploy_gateway_domain }}
  {{- end -}}
{{- end -}}
{{- define "gateway_ssl_enable" -}}
  {{- if eq (or .Values.deploy_service_protocol "http") "https" -}}
    true
  {{- else -}}
    false
  {{- end }}
{{- end -}}
{{- define "gateway_scheme" -}}
  {{- if eq (or .Values.deploy_service_protocol "http") "https" -}}
    HTTPS
  {{- else -}}
    HTTP
  {{- end }}
{{- end -}}
{{- define "deploy_disable_iportal" -}}
  {{ .Values.deploy_disable_iportal | default "false" }}
{{- end -}}
{{- define "storage_class_name" -}}
  {{- if .Values.deploy_nfs_server -}}
    appset-storage-class-gisappset
  {{- else if .Values.deploy_storage_class_name -}}
    {{ .Values.deploy_storage_class_name }}
  {{- else -}}
    appset-storage-class-gisappset
  {{- end -}}
{{- end -}}
{{- define "deploy_domain_ip" -}}
  {{ .Values.deploy_domain_ip | default .Values.deploy_kubernetes_public_ip }}
{{- end -}}
{{- define "deploy_image_namespace" -}}
  {{ .Values.deploy_image_namespace | default "supermap" }}
{{- end -}}
{{- define "deploy_ispeco_user_name" -}}
  {{ .Values.deploy_ispeco_user_name | default "user_admin" | b64enc }}
{{- end -}}
{{- define "deploy_ispeco_password" -}}
  {{ "Supermap1997" | b64enc }}
{{- end -}}
{{- define "deploy_async_function_enabled" -}}
  {{ .Values.deploy_async_function_enabled | default "false" }}
{{- end -}}
{{- define "deploy_sync_function_enabled" -}}
  {{ .Values.deploy_sync_function_enabled | default "false" }}
{{- end -}}
{{- define "deploy_kubernetes_public_ip" -}}
  {{ .Values.deploy_kubernetes_public_ip }}
{{- end -}}
{{- define "deploy_gateway_certificate" -}}
 {{ .Files.Get (.Values.deploy_gateway_certificate_path | default "") | b64enc }}
{{- end -}}
{{- define "deploy_gateway_certificate_private_key" -}}
 {{ .Files.Get (.Values.deploy_gateway_private_key_path | default "") | b64enc }}
{{- end -}}
################ custom service config
{{- define "deploy_bslicense_server_host" -}}
  {{- if ne .Values.deploy_disable_bslicense true -}}
    bslicense-server
  {{- else -}}
    {{ .Values.deploy_bslicense_server_host | default "bslicense-server" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_bslicense_server_port" -}}
  {{- if ne .Values.deploy_disable_bslicense true -}}
    9183
  {{- else -}}
    {{ .Values.deploy_bslicense_server_port | default "9183" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_bslicense_server_url" -}}
{{- printf "ws://bslicense-server.%s.svc.cluster.local:9183" .Release.Namespace -}} 
{{- end -}}
{{- define "deploy_bslicense_ui_host" -}}
  {{- if ne .Values.deploy_disable_bslicense true -}}
    bslicense-ui
  {{- else -}}
    {{ .Values.deploy_bslicense_ui_host | default "bslicense-ui" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_bslicense_ui_port" -}}
    {{ .Values.deploy_bslicense_ui_port | default "9283" }}
{{- end -}}
{{- define "deploy_bslicense_ui_url" -}}
{{- if and (eq .Values.deploy_disable_bslicense true) (.Values.deploy_bslicense_ui_host) -}}
http://{{ template "deploy_bslicense_ui_host" . }}:{{ template "deploy_bslicense_ui_port" . }}
{{- else -}}
http://{{ .Values.deploy_kubernetes_public_ip }}:{{ template "deploy_bslicense_ui_port" . }}
{{- end -}}
{{- end -}}
{{- define "deploy_consul_server_host" -}}
  {{- if ne .Values.deploy_disable_consul_server true -}}
    consul-server
  {{- else -}}
    {{ .Values.deploy_consul_server_host | default "consul-server" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_consul_server_port" -}}
  {{- if ne .Values.deploy_disable_consul_server true -}}
    8500
  {{- else -}}
    {{ .Values.deploy_consul_server_port | default "8500" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_database_type" -}}
  {{- if ne .Values.deploy_disable_ispeco_database true -}}
    mariadb
  {{- else -}}
    {{ .Values.deploy_ispeco_database_type | default "mariadb" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_database_host" -}}
  {{- if ne .Values.deploy_disable_ispeco_database true -}}
    ispeco-mysql
  {{- else -}}
    {{ .Values.deploy_ispeco_database_host | default "ispeco-mysql" }}
  {{- end -}}  
{{- end -}}
{{- define "deploy_ispeco_database_port" -}}
  {{- if ne .Values.deploy_disable_ispeco_database true -}}
    3306
  {{- else -}}
    {{ .Values.deploy_ispeco_database_port | default "3306" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_database_username" -}}
  {{- if ne .Values.deploy_disable_ispeco_database true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_ispeco_database_username | default "supermap" |  b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_database_password" -}}
  {{- if ne .Values.deploy_disable_ispeco_database true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_ispeco_database_password | default "supermap" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_database_jdbc_url" -}}
  {{- if eq .Values.deploy_ispeco_database_type "postgresql" -}}
    jdbc:{{ template "deploy_ispeco_database_type" . }}://{{ template "deploy_ispeco_database_host" . }}:{{ template "deploy_ispeco_database_port" . }}/ispeco?autoReconnect=true&useSSL=false&useUnicode=true&characterEncoding=utf8&stringtype=unspecified
  {{- else -}}
    jdbc:{{ template "deploy_ispeco_database_type" . }}://{{ template "deploy_ispeco_database_host" . }}:{{ template "deploy_ispeco_database_port" . }}/ispeco?autoReconnect=true&useSSL=false&useUnicode=true&characterEncoding=utf8
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_phpmyadmin_host" -}}
  {{- if ne .Values.deploy_disable_ispeco_phpmyadmin true -}}
    ispeco-phpmyadmin
  {{- else -}}
    {{ .Values.deploy_ispeco_phpmyadmin_host | default "ispeco-phpmyadmin" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_ispeco_phpmyadmin_port" -}}
  {{- if ne .Values.deploy_disable_ispeco_phpmyadmin true -}}
    89
  {{- else -}}
    {{ .Values.deploy_ispeco_phpmyadmin_port | default "89" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_keycloak_host" -}}
  {{- if ne .Values.deploy_disable_keycloak true -}}
    keycloak-internal
  {{- else -}}
    {{ .Values.deploy_keycloak_host | default "keycloak-internal" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_keycloak_port" -}}
  {{- if ne .Values.deploy_disable_keycloak true -}}
    8080
  {{- else -}}
    {{ .Values.deploy_keycloak_port | default "8080" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_keycloak_url" -}}
  {{- if eq .Values.deploy_disable_keycloak true -}}
    http://{{- template "deploy_keycloak_host" . -}}:{{- template "deploy_keycloak_port" . -}}/auth
  {{- else -}}
    none
  {{- end -}}
{{- end -}}
{{- define "deploy_keycloak_import_realm_url" -}}
  {{- if eq .Values.deploy_disable_keycloak true -}}
    http://{{- template "deploy_keycloak_host" . -}}:{{- template "deploy_keycloak_port" . -}}/auth
  {{- else -}}
    http://keycloak-internal:8081/auth
  {{- end -}}
{{- end -}}
{{- define "keycloak_auth_url" -}}
  {{- if ne .Values.deploy_disable_keycloak true -}}
    {{ template "gateway_address_reg" . }}/auth
  {{- else -}}
    http://{{ template "deploy_keycloak_host" . }}:{{ template "deploy_keycloak_port" . }}/auth
  {{- end -}}
{{- end -}}
{{- define "deploy_keycloak_admin_username" -}}
  {{- if ne .Values.deploy_disable_keycloak true -}}
    {{ "admin" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_keycloak_admin_username | default "admin" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_keycloak_admin_password" -}}
  {{- if ne .Values.deploy_disable_keycloak true -}}
    {{ "keycloak" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_keycloak_admin_password | default "keycloak" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_keycloak_postgresql_host" -}}
  {{- if ne .Values.deploy_disable_keycloak_postgresql true -}}
    keycloak-postgresql
  {{- else -}}
    {{ .Values.deploy_keycloak_postgresql_host | default "keycloak-postgresql" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_keycloak_postgresql_port" -}}
  {{- if ne .Values.deploy_disable_keycloak_postgresql true -}}
    5432
  {{- else -}}
    {{ .Values.deploy_keycloak_postgresql_port | default "5432" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_keycloak_postgresql_username" -}}
  {{- if ne .Values.deploy_disable_keycloak_postgresql true -}}
    supermap
  {{- else -}}
    {{ .Values.deploy_keycloak_postgresql_username | default "supermap" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_keycloak_postgresql_password" -}}
  {{- if ne .Values.deploy_disable_keycloak_postgresql true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_keycloak_postgresql_password | default "supermap" | b64enc }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_rabbitmq_host" -}}
  {{- if ne .Values.deploy_disable_rabbitmq true -}}
    rabbitmq
  {{- else -}}
    {{ .Values.deploy_rabbitmq_host | default "rabbitmq" }}
  {{- end -}}
{{- end -}}
{{- define "deploy_rabbitmq_port" -}}
  {{- if ne .Values.deploy_disable_rabbitmq true -}}
    5672
  {{- else -}}
    {{ .Values.deploy_rabbitmq_port | default "5672" }}
  {{- end -}}
{{- end -}}
{{- define "deploy_rabbitmq_username" -}}
  {{- if ne .Values.deploy_disable_rabbitmq true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_rabbitmq_username | default "supermap" | b64enc }}
  {{- end -}}
{{- end -}}
{{- define "deploy_rabbitmq_password" -}}
  {{- if ne .Values.deploy_disable_rabbitmq true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_rabbitmq_password | default "supermap" | b64enc }}
  {{- end -}}
{{- end -}}
{{- define "deploy_redis_host" -}}
  {{- if ne .Values.deploy_disable_redis true -}}
    redis
  {{- else -}}
    {{ .Values.deploy_redis_host | default "redis" }}
  {{- end -}}   
{{- end -}}
{{- define "deploy_redis_port" -}}
  {{- if ne .Values.deploy_disable_redis true -}}
    6379
  {{- else -}}
    {{ .Values.deploy_redis_port | default "6379" }}
  {{- end -}}
{{- end -}}
{{- define "deploy_redis_username" -}}
  {{- if ne .Values.deploy_disable_redis true -}}
    {{ "" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_redis_username | default "" | b64enc }}
  {{- end -}}
{{- end -}}
{{- define "deploy_redis_password" -}}
  {{- if ne .Values.deploy_disable_redis true -}}
    {{ "" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_redis_password | default "" | b64enc }}
  {{- end -}}
{{- end -}}
{{- define "deploy_iportal_database_type" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
    mysql
  {{- else -}}
    {{ .Values.deploy_iportal_database_type | default "mysql" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_database_type_upper" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
  {{ "mysql" | upper }}
  {{- else -}}
    {{ .Values.deploy_iportal_database_type | default "mysql" | upper }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_database_host" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
    iportal-mysql
  {{- else -}}
    {{ .Values.deploy_iportal_database_host | default "iportal-mysql" }}
  {{- end -}}  
{{- end -}}
{{- define "deploy_iportal_database_port" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
    3306
  {{- else -}}
    {{ .Values.deploy_iportal_database_port | default "3306" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_database_username" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
    supermap
  {{- else -}}
    {{ .Values.deploy_iportal_database_username | default "supermap" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_database_password" -}}
  {{- if ne .Values.deploy_disable_iportal_database true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_iportal_database_password | default "supermap" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_phpmyadmin_host" -}}
  {{- if ne .Values.deploy_disable_iportal_phpmyadmin true -}}
    iportal-phpmyadmin
  {{- else -}}
    {{ .Values.deploy_iportal_phpmyadmin_host | default "iportal-phpmyadmin" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_phpmyadmin_port" -}}
  {{- if ne .Values.deploy_disable_iportal_phpmyadmin true -}}
    89
  {{- else -}}
    {{ .Values.deploy_iportal_phpmyadmin_port | default "89" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_postgis_host" -}}
  {{- if ne .Values.deploy_disable_iportal_postgis true -}}
    iportal-mysql
  {{- else -}}
    {{ .Values.deploy_iportal_postgis_host | default "iportal-postgis" }}
  {{- end -}}  
{{- end -}}
{{- define "deploy_iportal_postgis_port" -}}
  {{- if ne .Values.deploy_disable_iportal_postgis true -}}
    5432
  {{- else -}}
    {{ .Values.deploy_iportal_postgis_port | default "5432" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_postgis_username" -}}
  {{- if ne .Values.deploy_disable_iportal_postgis true -}}
    admin
  {{- else -}}
    {{ .Values.deploy_iportal_postgis_username | default "admin" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_postgis_password" -}}
  {{- if ne .Values.deploy_disable_iportal_postgis true -}}
    {{ "admin" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_iportal_postgis_password | default "admin" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_memcached_host" -}}
  {{- if ne .Values.deploy_disable_iportal_memcached true -}}
    iportal-memcached
  {{- else -}}
    {{ .Values.deploy_iportal_memcached_host | default "iportal-memcached" }}
  {{- end -}}  
{{- end -}}
{{- define "deploy_iportal_memcached_port" -}}
  {{- if ne .Values.deploy_disable_iportal_memcached true -}}
    11211
  {{- else -}}
    {{ .Values.deploy_iportal_memcached_port | default "11211" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_elasticsearch_host" -}}
  {{- if ne .Values.deploy_disable_iportal_elasticsearch true -}}
    iportal-elasticsearch
  {{- else -}}
    {{ .Values.deploy_iportal_elasticsearch_host | default "iportal-elasticsearch" }}
  {{- end -}}  
{{- end -}}
{{- define "deploy_iportal_elasticsearch_rest_port" -}}
  {{- if ne .Values.deploy_disable_iportal_elasticsearch true -}}
    9200
  {{- else -}}
    {{ .Values.deploy_iportal_elasticsearch_rest_port | default "9200" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iportal_elasticsearch_tcp_port" -}}
  {{- if ne .Values.deploy_disable_iportal_elasticsearch true -}}
    9300
  {{- else -}}
    {{ .Values.deploy_iportal_elasticsearch_tcp_port | default "9300" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_iserver_geometry_enabled" -}}
  {{- if eq .Values.deploy_disable_iserver_geometry true -}}
    false
  {{- else -}}
    true
  {{- end -}}
{{- end -}}
{{- define "deploy_iserver_datacatalog_enabled" -}}
  {{- if eq .Values.deploy_disable_iserver_datacatalog true -}}
    false
  {{- else -}}
    true
  {{- end -}}
{{- end -}}
{{- define "deploy_prometheus_enabled" -}}
  {{- if eq .Values.deploy_disable_prometheus true -}}
    false
  {{- else -}}
    true
  {{- end -}}
{{- end }}
{{- define "deploy_prometheus_url" -}}
{{- if ne .Values.deploy_disable_prometheus true -}}
  http://prometheus:9090
{{- else -}}
  none
{{- end -}}
{{- end -}}
{{- define "deploy_grafana_host" -}}
  {{- if ne .Values.deploy_disable_grafana true -}}
    grafana
  {{- else -}}
    {{ .Values.deploy_grafana_host | default "grafana" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_port" -}}
  {{- if ne .Values.deploy_disable_grafana true -}}
    3000
  {{- else -}}
    {{ .Values.deploy_grafana_port | default "3000" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_context_path" -}}
  {{- if eq .Values.deploy_disable_grafana true -}}
    {{ .Values.deploy_grafana_context_path | default "" }}
  {{- else -}}
    {{ "" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_enabled" -}}
  {{- if or (ne .Values.deploy_disable_grafana true) ( .Values.deploy_grafana_host) -}}
    true
  {{- else -}}
    false
  {{- end -}}
{{- end -}}
{{- define "deploy_grafana_url" -}}
  {{- if and (eq .Values.deploy_disable_grafana true) (.Values.deploy_grafana_host) -}}
    http://{{ template "deploy_grafana_host" . }}:{{ template "deploy_grafana_port" . }}{{ template "deploy_grafana_context_path" . }}
  {{- else -}}
    none
  {{- end -}}
{{- end -}}

{{- define "deploy_grafana_url_for_import" -}}
  {{- if eq .Values.deploy_disable_grafana true -}}
    http://{{ template "deploy_grafana_host" . }}:{{ template "deploy_grafana_port" . }}{{ template "deploy_grafana_context_path" . }}
  {{- else -}}
    http://grafana:3000/manager/grafana
  {{- end -}}
{{- end -}}
{{- define "deploy_grafana_postgresql_host" -}}
  {{- if ne .Values.deploy_disable_grafana_postgresql true -}}
    grafana-database
  {{- else -}}
    {{ .Values.deploy_grafana_postgresql_host | default "grafana-database" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_postgresql_port" -}}
  {{- if ne .Values.deploy_disable_grafana_postgresql true -}}
    5432
  {{- else -}}
    {{ .Values.deploy_grafana_postgresql_port | default "5432" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_postgresql_username" -}}
  {{- if ne .Values.deploy_disable_grafana_postgresql true -}}
    supermap
  {{- else -}}
    {{ .Values.deploy_grafana_postgresql_username | default "supermap" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_grafana_postgresql_password" -}}
  {{- if ne .Values.deploy_disable_grafana_postgresql true -}}
    {{ "supermap" | b64enc }}
  {{- else -}}
    {{ .Values.deploy_grafana_postgresql_password | default "supermap" | b64enc }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_blackbox_exporter_host" -}}
  {{- if ne .Values.deploy_disable_blackbox_exporter true -}}
    blackbox-exporter
  {{- else -}}
    {{ .Values.deploy_blackbox_exporter_host | default "blackbox-exporter" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_blackbox_exporter_port" -}}
  {{- if ne .Values.deploy_disable_blackbox_exporter true -}}
    9115
  {{- else -}}
    {{ .Values.deploy_blackbox_exporter_port | default "9115" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_k8s_dashboard_host" -}}
  {{- if ne .Values.deploy_disable_k8s_dashboard true -}}
    k8s-dashboard
  {{- else -}}
    {{ .Values.deploy_k8s_dashboard_host | default "k8s-dashboard" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_k8s_dashboard_port" -}}
  {{- if ne .Values.deploy_disable_k8s_dashboard true -}}
    9090
  {{- else -}}
    {{ .Values.deploy_k8s_dashboard_port | default "9090" }}
  {{- end -}} 
{{- end -}}
{{- define "deploy_k8s_dashboard_enabled" -}}
  {{- if or (ne .Values.deploy_disable_k8s_dashboard true) ( .Values.deploy_k8s_dashboard_host) -}}
    true
  {{- else -}}
    false
  {{- end -}}
{{- end -}}
{{- define "imanager.labels" -}}
type: imanager
kind: imanager-base
{{- end -}}
{{- define "icloud_native.labels" -}}
type: icloud-native
kind: icloud-native-dev
{{- end -}}
{{- define "affinity" -}}
{{- with .Values.affinity -}}
affinity:
  {{- toYaml . | nindent 2 -}}
{{- end -}}
{{- end -}}
{{- define "tolerations" -}}
{{- with .Values.tolerations -}}
tolerations:
  {{- toYaml . | nindent 2 -}}
{{- end -}}
{{- end -}}
